part_1/rails/config/routes.rb
Rails.application.routes.draw do
  root "presses#new"

  resources :presses
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

part_1/rails/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

part_1/rails/app/models/press.rb
class Press < ApplicationRecord
end

part_1/rails/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

part_1/rails/app/controllers/presses_controller.rb
class PressesController < ApplicationController
  before_action :set_press, only: %i[ show edit update destroy ]

  # GET /presses or /presses.json
  def index
    @presses = Press.all
  end

  # GET /presses/1 or /presses/1.json
  def show
  end

  # GET /presses/new
  def new
    @press = Press.new
  end

  # GET /presses/1/edit
  def edit
  end

  # POST /presses or /presses.json
  def create
    @press = Press.new(press_params)

    respond_to do |format|
      if @press.save
        format.html { redirect_to press_url(@press), notice: "Press was successfully created." }
        format.json { render :show, status: :created, location: @press }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @press.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /presses/1 or /presses/1.json
  def update
    respond_to do |format|
      if @press.update(press_params)
        format.html { redirect_to press_url(@press), notice: "Press was successfully updated." }
        format.json { render :show, status: :ok, location: @press }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @press.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /presses/1 or /presses/1.json
  def destroy
    @press.destroy

    respond_to do |format|
      format.html { redirect_to presses_url, notice: "Press was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_press
      @press = Press.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def press_params
      params.fetch(:press, {})
    end
end

part_1/rails/app/helpers/application_helper.rb
module ApplicationHelper
end

part_1/rails/app/helpers/presses_helper.rb
module PressesHelper
end

part_1/rails/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsExample</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

part_1/rails/app/views/presses/_form.html.erb
<%= form_with(model: press) do |form| %>
  <% if press.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(press.errors.count, "error") %> prohibited this press from being saved:</h2>

      <ul>
        <% press.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.submit %>
  </div>
<% end %>

part_1/rails/app/views/presses/_press.html.erb
<div id="<%= dom_id press %>">
</div>

part_1/rails/app/views/presses/edit.html.erb
<h1>Editing press</h1>

<%= render "form", press: @press %>

<br>

<div>
  <%= link_to "Show this press", @press %> |
  <%= link_to "Back to presses", presses_path %>
</div>

part_1/rails/app/views/presses/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Presses</h1>

<table>
  <thead>
    <tr>
      <th colspan="4"></th>
    </tr>
  </thead>

  <tbody>
    <% @presses.each do |press| %>
      <tr>
        <td><%= press.created_at %> </td>
        <td><%= link_to 'Show', press %></td>
        <td><%= link_to 'Edit', edit_press_path(press) %></td>
        <td><%= link_to 'Destroy', press, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to "New press", new_press_path %>

part_1/rails/app/views/presses/new.html.erb
<h1>New press</h1>

<%= render "form", press: @press %>

<br>

<div>
  <%= link_to "Back to presses", presses_path %>
</div>

part_1/rails/app/views/presses/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @press %>

<h1> Pressed at: <%= @press.created_at %> </h1>


<div>
  <%= link_to "Edit this press", edit_press_path(@press) %> |
  <%= link_to "Back to presses", presses_path %>

  <%= button_to "Destroy this press", @press, method: :delete %>
</div>